float4x4 tW: WORLD;        //the models world matrix
float4x4 tV: VIEW;         //view matrix as set via Renderer (DX9)
float4x4 tP: PROJECTION;   //projection matrix as set via Renderer (DX9)
float4x4 tWVP: WORLDVIEWPROJECTION;



texture Tex <string uiname="Texture Mask";>;
float4x4 tTex <string uiname="Texture Transform Mask";>;                  //Texture Transform
sampler ImageSamplerMask = sampler_state    //sampler for doing the texture-lookup
{
    Texture   = (Tex);          //apply a texture to the sampler
    MipFilter = LINEAR;         //set the sampler states
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};



texture ImageTexture1
<string uiname="Texture 1";>;
float4x4 tTex1 <string uiname="Texture 1 Transform";>;
sampler2D ImageSampler1 = sampler_state
{
    Texture = <ImageTexture1>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = LINEAR;
};

texture ImageTexture2
<string uiname="Texture 2";>;
float4x4 tTex2 <string uiname="Texture 2 Transform";>;
sampler2D ImageSampler2 = sampler_state
{
    Texture = <ImageTexture2>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = LINEAR;
};

///////////////////////////////////////vertexshader///////////////////////

float Alpha <String uiname="Alpha"; float uimin=0.0;> = 1;

struct VS_OUTPUT
{
    float4 Pos  : POSITION;
    float4 TexC : TEXCOORD0;
    float4 TexC1 : TEXCOORD1;
    float4 TexC2 : TEXCOORD2;
};

VS_OUTPUT VS(
    float4 Pos  : POSITION,
    float4 TexC : TEXCOORD,
    float4 TexC1 : TEXCOORD1,
    float4 TexC2 : TEXCOORD2)
{
    //inititalize all fields of output struct with 0
    VS_OUTPUT Out = (VS_OUTPUT)0;

    //transform position
    Pos = mul(Pos, tWVP);
    Out.Pos  = Pos;
     
    //transform texturecoordinates
    Out.TexC1 =mul(TexC, tTex1);
    Out.TexC2 =mul(TexC, tTex2);
    Out.TexC = mul(TexC, tTex);

    return Out;
}

////////////////////////////////pixelshader////////////////////////////////////

float4 dispPS(float4 TexC: TEXCOORD0,float4 TexC1: TEXCOORD1,float4 TexC2: TEXCOORD2) : COLOR
{   
	float4 disp = ( ( (float4)tex2D(ImageSamplerMask, TexC) ) );
	float4 texCol1 = tex2D(ImageSampler1,TexC2);
	float4 texCol2 = tex2D(ImageSampler2,TexC1);

        return lerp(texCol2,texCol1 , disp*Alpha);
        
} 
/////////////////////////////////technique//////////////////////////////////// 

technique BlendByTexture {
	pass TexturePass  {
		VertexShader = compile vs_2_0 VS();
	
		PixelShader  = compile ps_2_a dispPS();
	}
}

/***************************** eof ***/
